diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
index ffa6180eff..c98f26df91 100644
--- a/src/backend/storage/ipc/procarray.c
+++ b/src/backend/storage/ipc/procarray.c
@@ -896,366 +428,224 @@ ProcArrayApplyRecoveryInfo(RunningTransactions running)
 
 	Assert(TransactionIdIsValid(ShmemVariableCache->nextXid));
 
-	KnownAssignedXidsDisplay(trace_recovery(DEBUG3));
-	if (standbyState == STANDBY_SNAPSHOT_READY)
-		elog(trace_recovery(DEBUG1), "recovery snapshots are now enabled");
-	else
-		elog(trace_recovery(DEBUG1),
-			 "recovery snapshot waiting for non-overflowed snapshot or "
-			 "until oldest active xid on standby is at least %u (now %u)",
-			 standbySnapshotPendingXmin,
-			 running->oldestRunningXid);
+	standbyState = STANDBY_SNAPSHOT_READY;
+	elog(trace_recovery(DEBUG1), "recovery snapshots are now enabled");
 }
 
 /*
- * ProcArrayApplyXidAssignment
- *		Process an XLOG_XACT_ASSIGNMENT WAL record
+ * TransactionIdIsActive -- is xid the top-level XID of an active backend?
+ *
+ * This ignores prepared transactions and subtransactions, since that's not
+ * needed for current uses.
  */
-void
-ProcArrayApplyXidAssignment(TransactionId topxid,
-							int nsubxids, TransactionId *subxids)
+bool
+TransactionIdIsActive(TransactionId xid)
 {
-	TransactionId max_xid;
+	bool		result = false;
+	ProcArrayStruct *arrayP = procArray;
 	int			i;
 
-	Assert(standbyState >= STANDBY_INITIALIZED);
-
-	max_xid = TransactionIdLatest(topxid, nsubxids, subxids);
-
-	/*
-	 * Mark all the subtransactions as observed.
-	 *
-	 * NOTE: This will fail if the subxid contains too many previously
-	 * unobserved xids to fit into known-assigned-xids. That shouldn't happen
-	 * as the code stands, because xid-assignment records should never contain
-	 * more than PGPROC_MAX_CACHED_SUBXIDS entries.
-	 */
-	RecordKnownAssignedTransactionIds(max_xid);
+	LWLockAcquire(ProcArrayLock, LW_SHARED);
 
-	/*
-	 * Notice that we update pg_subtrans with the top-level xid, rather than
-	 * the parent xid. This is a difference between normal processing and
-	 * recovery, yet is still correct in all cases. The reason is that
-	 * subtransaction commit is not marked in clog until commit processing, so
-	 * all aborted subtransactions have already been clearly marked in clog.
-	 * As a result we are able to refer directly to the top-level
-	 * transaction's state rather than skipping through all the intermediate
-	 * states in the subtransaction tree. This should be the first time we
-	 * have attempted to SubTransSetParent().
-	 */
-	for (i = 0; i < nsubxids; i++)
-		SubTransSetParent(subxids[i], topxid);
+	for (i = 0; i < arrayP->numProcs; i++)
+	{
+		int			pgprocno = arrayP->pgprocnos[i];
+		volatile PGPROC *proc = &allProcs[pgprocno];
+		volatile PGXACT *pgxact = &allPgXact[pgprocno];
+		TransactionId pxid;
 
-	/* KnownAssignedXids isn't maintained yet, so we're done for now */
-	if (standbyState == STANDBY_INITIALIZED)
-		return;
+		/* Fetch xid just once - see GetNewTransactionId */
+		pxid = pgxact->xid;
 
-	/*
-	 * Uses same locking as transaction commit
-	 */
-	LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
+		if (!TransactionIdIsValid(pxid))
+			continue;
 
-	/*
-	 * Remove subxids from known-assigned-xacts.
-	 */
-	KnownAssignedXidsRemoveTree(InvalidTransactionId, nsubxids, subxids);
+		if (proc->pid == 0)
+			continue;			/* ignore prepared transactions */
 
-	/*
-	 * Advance lastOverflowedXid to be at least the last of these subxids.
-	 */
-	if (TransactionIdPrecedes(procArray->lastOverflowedXid, max_xid))
-		procArray->lastOverflowedXid = max_xid;
+		if (TransactionIdEquals(pxid, xid))
+		{
+			result = true;
+			break;
+		}
+	}
 
 	LWLockRelease(ProcArrayLock);
+
+	return result;
 }
 
 /*
- * TransactionIdIsInProgress -- is given transaction running in some backend
- *
- * Aside from some shortcuts such as checking RecentXmin and our own Xid,
- * there are four possibilities for finding a running transaction:
- *
- * 1. The given Xid is a main transaction Id.  We will find this out cheaply
- * by looking at the PGXACT struct for each backend.
+ * AdvanceOldestActiveXid --
  *
- * 2. The given Xid is one of the cached subxact Xids in the PGPROC array.
- * We can find this out cheaply too.
- *
- * 3. In Hot Standby mode, we must search the KnownAssignedXids list to see
- * if the Xid is running on the master.
- *
- * 4. Search the SubTrans tree to find the Xid's topmost parent, and then see
- * if that is running according to PGXACT or KnownAssignedXids.  This is the
- * slowest way, but sadly it has to be done always if the others failed,
- * unless we see that the cached subxact sets are complete (none have
- * overflowed).
- *
- * ProcArrayLock has to be held while we do 1, 2, 3.  If we save the top Xids
- * while doing 1 and 3, we can release the ProcArrayLock while we do 4.
- * This buys back some concurrency (and we can't retrieve the main Xids from
- * PGXACT again anyway; see GetNewTransactionId).
+ * Advance oldestActiveXid. 'oldXid' is the current value, and it's known to be
+ * finished now.
  */
-bool
-TransactionIdIsInProgress(TransactionId xid)
+static void
+AdvanceOldestActiveXid(TransactionId myXid)
 {
-	static TransactionId *xids = NULL;
-	int			nxids = 0;
-	ProcArrayStruct *arrayP = procArray;
-	TransactionId topxid;
-	int			i,
-				j;
+	TransactionId nextXid;
+	TransactionId xid;
+	TransactionId oldValue;
 
-	/*
-	 * Don't bother checking a transaction older than RecentXmin; it could not
-	 * possibly still be running.  (Note: in particular, this guarantees that
-	 * we reject InvalidTransactionId, FrozenTransactionId, etc as not
-	 * running.)
-	 */
-	if (TransactionIdPrecedes(xid, RecentXmin))
-	{
-		xc_by_recent_xmin_inc();
-		return false;
-	}
+	oldValue = pg_atomic_read_u32(&ShmemVariableCache->oldestActiveXid);
 
-	/*
-	 * We may have just checked the status of this transaction, so if it is
-	 * already known to be completed, we can fall out without any access to
-	 * shared memory.
-	 */
-	if (TransactionIdIsKnownCompleted(xid))
-	{
-		xc_by_known_xact_inc();
-		return false;
-	}
+	/* Quick exit if we were not the oldest active XID. */
+	if (myXid != oldValue)
+		return;
 
-	/*
-	 * Also, we can handle our own transaction (and subtransactions) without
-	 * any access to shared memory.
-	 */
-	if (TransactionIdIsCurrentTransactionId(xid))
-	{
-		xc_by_my_xact_inc();
-		return true;
-	}
+	xid = myXid;
+	TransactionIdAdvance(xid);
 
-	/*
-	 * If first time through, get workspace to remember main XIDs in. We
-	 * malloc it permanently to avoid repeated palloc/pfree overhead.
-	 */
-	if (xids == NULL)
+	for (;;)
 	{
 		/*
-		 * In hot standby mode, reserve enough space to hold all xids in the
-		 * known-assigned list. If we later finish recovery, we no longer need
-		 * the bigger array, but we don't bother to shrink it.
+		 * Current nextXid is the upper bound, if there are no transactions
+		 * active at all.
 		 */
-		int			maxxids = RecoveryInProgress() ? TOTAL_MAX_CACHED_SUBXIDS : arrayP->maxProcs;
-
-		xids = (TransactionId *) malloc(maxxids * sizeof(TransactionId));
-		if (xids == NULL)
-			ereport(ERROR,
-					(errcode(ERRCODE_OUT_OF_MEMORY),
-					 errmsg("out of memory")));
-	}
+		/* assume we can read nextXid atomically without holding XidGenlock. */
+		nextXid = ShmemVariableCache->nextXid;
+		/* Scan the CSN Log for the next active xid */
+		xid = CSNLogGetNextActiveXid(xid, nextXid);
 
-	LWLockAcquire(ProcArrayLock, LW_SHARED);
-
-	/*
-	 * Now that we have the lock, we can check latestCompletedXid; if the
-	 * target Xid is after that, it's surely still running.
-	 */
-	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid, xid))
-	{
-		LWLockRelease(ProcArrayLock);
-		xc_by_latest_xid_inc();
-		return true;
-	}
-
-	/* No shortcuts, gotta grovel through the array */
-	for (i = 0; i < arrayP->numProcs; i++)
-	{
-		int			pgprocno = arrayP->pgprocnos[i];
-		volatile PGPROC *proc = &allProcs[pgprocno];
-		volatile PGXACT *pgxact = &allPgXact[pgprocno];
-		TransactionId pxid;
-
-		/* Ignore my own proc --- dealt with it above */
-		if (proc == MyProc)
-			continue;
-
-		/* Fetch xid just once - see GetNewTransactionId */
-		pxid = pgxact->xid;
-
-		if (!TransactionIdIsValid(pxid))
-			continue;
-
-		/*
-		 * Step 1: check the main Xid
-		 */
-		if (TransactionIdEquals(pxid, xid))
-		{
-			LWLockRelease(ProcArrayLock);
-			xc_by_main_xid_inc();
-			return true;
-		}
-
-		/*
-		 * We can ignore main Xids that are younger than the target Xid, since
-		 * the target could not possibly be their child.
-		 */
-		if (TransactionIdPrecedes(xid, pxid))
-			continue;
-
-		/*
-		 * Step 2: check the cached child-Xids arrays
-		 */
-		for (j = pgxact->nxids - 1; j >= 0; j--)
+		if (xid == oldValue)
 		{
-			/* Fetch xid just once - see GetNewTransactionId */
-			TransactionId cxid = proc->subxids.xids[j];
-
-			if (TransactionIdEquals(cxid, xid))
-			{
-				LWLockRelease(ProcArrayLock);
-				xc_by_child_xid_inc();
-				return true;
-			}
+			/* nothing more to do */
+			break;
 		}
 
 		/*
-		 * Save the main Xid for step 4.  We only need to remember main Xids
-		 * that have uncached children.  (Note: there is no race condition
-		 * here because the overflowed flag cannot be cleared, only set, while
-		 * we hold ProcArrayLock.  So we can't miss an Xid that we need to
-		 * worry about.)
+		 * Update oldestActiveXid with that value.
 		 */
-		if (pgxact->overflowed)
-			xids[nxids++] = pxid;
-	}
-
-	/*
-	 * Step 3: in hot standby mode, check the known-assigned-xids list.  XIDs
-	 * in the list must be treated as running.
-	 */
-	if (RecoveryInProgress())
-	{
-		/* none of the PGXACT entries should have XIDs in hot standby mode */
-		Assert(nxids == 0);
-
-		if (KnownAssignedXidExists(xid))
+		if (!pg_atomic_compare_exchange_u32(&ShmemVariableCache->oldestActiveXid,
+											&oldValue,
+											xid))
 		{
-			LWLockRelease(ProcArrayLock);
-			xc_by_known_assigned_inc();
-			return true;
+			/*
+			 * Someone beat us to it. This can happen if we hit the race
+			 * condition described below. That's OK. We're no longer the oldest active
+			 * XID in that case, so we're done.
+			 */
+			Assert(TransactionIdFollows(oldValue, myXid));
+			break;
 		}
 
 		/*
-		 * If the KnownAssignedXids overflowed, we have to check pg_subtrans
-		 * too.  Fetch all xids from KnownAssignedXids that are lower than
-		 * xid, since if xid is a subtransaction its parent will always have a
-		 * lower value.  Note we will collect both main and subXIDs here, but
-		 * there's no help for it.
+		 * We're not necessarily done yet. It's possible that the XID that we saw
+		 * as still running committed just before we updated oldestActiveXid.
+		 * She didn't see herself as the oldest transaction, so she wouldn't
+		 * update oldestActiveXid. Loop back to check the XID that we saw as
+		 * the oldest in-progress one is still in-progress, and if not, update
+		 * oldestActiveXid again, on behalf of that transaction.
 		 */
-		if (TransactionIdPrecedesOrEquals(xid, procArray->lastOverflowedXid))
-			nxids = KnownAssignedXidsGet(xids, xid);
-	}
-
-	LWLockRelease(ProcArrayLock);
-
-	/*
-	 * If none of the relevant caches overflowed, we know the Xid is not
-	 * running without even looking at pg_subtrans.
-	 */
-	if (nxids == 0)
-	{
-		xc_no_overflow_inc();
-		return false;
-	}
-
-	/*
-	 * Step 4: have to check pg_subtrans.
-	 *
-	 * At this point, we know it's either a subtransaction of one of the Xids
-	 * in xids[], or it's not running.  If it's an already-failed
-	 * subtransaction, we want to say "not running" even though its parent may
-	 * still be running.  So first, check pg_xact to see if it's been aborted.
-	 */
-	xc_slow_answer_inc();
-
-	if (TransactionIdDidAbort(xid))
-		return false;
-
-	/*
-	 * It isn't aborted, so check whether the transaction tree it belongs to
-	 * is still running (or, more precisely, whether it was running when we
-	 * held ProcArrayLock).
-	 */
-	topxid = SubTransGetTopmostTransaction(xid);
-	Assert(TransactionIdIsValid(topxid));
-	if (!TransactionIdEquals(topxid, xid))
-	{
-		for (i = 0; i < nxids; i++)
-		{
-			if (TransactionIdEquals(xids[i], topxid))
-				return true;
-		}
+		oldValue = xid;
 	}
-
-	return false;
 }
 
+
 /*
- * TransactionIdIsActive -- is xid the top-level XID of an active backend?
- *
- * This differs from TransactionIdIsInProgress in that it ignores prepared
- * transactions, as well as transactions running on the master if we're in
- * hot standby.  Also, we ignore subtransactions since that's not needed
- * for current uses.
+ * This is like GetOldestXmin(NULL, true), but can return slightly stale, cached value.
  */
-bool
-TransactionIdIsActive(TransactionId xid)
+TransactionId
+GetRecentGlobalXmin(void)
 {
-	bool		result = false;
+	TransactionId globalXmin;
 	ProcArrayStruct *arrayP = procArray;
-	int			i;
+	int			index;
+	volatile TransactionId replication_slot_xmin = InvalidTransactionId;
+	volatile TransactionId replication_slot_catalog_xmin = InvalidTransactionId;
 
-	/*
-	 * Don't bother checking a transaction older than RecentXmin; it could not
-	 * possibly still be running.
-	 */
-	if (TransactionIdPrecedes(xid, RecentXmin))
-		return false;
+	if (TransactionIdIsValid(RecentGlobalXmin))
+		return RecentGlobalXmin;
 
 	LWLockAcquire(ProcArrayLock, LW_SHARED);
 
-	for (i = 0; i < arrayP->numProcs; i++)
+	/*
+	 * We initialize the MIN() calculation with oldestActiveXid. This
+	 * is a lower bound for the XIDs that might appear in the ProcArray later,
+	 * and so protects us against overestimating the result due to future
+	 * additions.
+	 */
+	globalXmin = pg_atomic_read_u32(&ShmemVariableCache->oldestActiveXid);
+	Assert(TransactionIdIsNormal(globalXmin));
+
+	for (index = 0; index < arrayP->numProcs; index++)
 	{
-		int			pgprocno = arrayP->pgprocnos[i];
-		volatile PGPROC *proc = &allProcs[pgprocno];
+		int			pgprocno = arrayP->pgprocnos[index];
 		volatile PGXACT *pgxact = &allPgXact[pgprocno];
-		TransactionId pxid;
 
 		/* Fetch xid just once - see GetNewTransactionId */
-		pxid = pgxact->xid;
+		TransactionId xid = pgxact->xid;
 
-		if (!TransactionIdIsValid(pxid))
+		/*
+		 * Backend is doing logical decoding which manages xmin separately,
+		 * check below.
+		 */
+		if (pgxact->vacuumFlags & PROC_IN_LOGICAL_DECODING)
 			continue;
 
-		if (proc->pid == 0)
-			continue;			/* ignore prepared transactions */
+		if (pgxact->vacuumFlags & PROC_IN_VACUUM)
+			continue;
 
-		if (TransactionIdEquals(pxid, xid))
-		{
-			result = true;
-			break;
-		}
+		/* First consider the transaction's own Xid, if any */
+		if (TransactionIdIsNormal(xid) &&
+			TransactionIdPrecedes(xid, globalXmin))
+			globalXmin = xid;
+
+		/*
+		 * Also consider the transaction's Xmin, if set.
+		 *
+		 * We must check both Xid and Xmin because a transaction might
+		 * have an Xmin but not (yet) an Xid; conversely, if it has an
+		 * Xid, that could determine some not-yet-set Xmin.
+		 */
+		xid = pgxact->xmin; /* Fetch just once */
+		if (TransactionIdIsNormal(xid) &&
+			TransactionIdPrecedes(xid, globalXmin))
+			globalXmin = xid;
 	}
 
+	/* fetch into volatile var while ProcArrayLock is held */
+	replication_slot_xmin = procArray->replication_slot_xmin;
+	replication_slot_catalog_xmin = procArray->replication_slot_catalog_xmin;
+
 	LWLockRelease(ProcArrayLock);
 
-	return result;
+	/* Update cached variables */
+	RecentGlobalXmin = globalXmin - vacuum_defer_cleanup_age;
+	if (!TransactionIdIsNormal(RecentGlobalXmin))
+		RecentGlobalXmin = FirstNormalTransactionId;
+
+	/* Check whether there's a replication slot requiring an older xmin. */
+	if (TransactionIdIsValid(replication_slot_xmin) &&
+		NormalTransactionIdPrecedes(replication_slot_xmin, RecentGlobalXmin))
+		RecentGlobalXmin = replication_slot_xmin;
+
+	/* Non-catalog tables can be vacuumed if older than this xid */
+	RecentGlobalDataXmin = RecentGlobalXmin;
+
+	/*
+	 * Check whether there's a replication slot requiring an older catalog
+	 * xmin.
+	 */
+	if (TransactionIdIsNormal(replication_slot_catalog_xmin) &&
+		NormalTransactionIdPrecedes(replication_slot_catalog_xmin, RecentGlobalXmin))
+		RecentGlobalXmin = replication_slot_catalog_xmin;
+
+	return RecentGlobalXmin;
 }
 
+TransactionId
+GetRecentGlobalDataXmin(void)
+{
+	if (TransactionIdIsValid(RecentGlobalDataXmin))
+		return RecentGlobalDataXmin;
+
+	(void) GetRecentGlobalXmin();
+	Assert(TransactionIdIsValid(RecentGlobalDataXmin));
+
+	return RecentGlobalDataXmin;
+}
 
 /*
  * GetOldestXmin -- returns oldest transaction that was running
@@ -1279,7 +669,7 @@ TransactionIdIsActive(TransactionId xid)
  * ignore concurrently running lazy VACUUMs because (a) they must be working
  * on other tables, and (b) they don't need to do snapshot-based lookups.
  *
- * This is also used to determine where to truncate pg_subtrans.  For that
+ * This is also used to determine where to truncate pg_csnlog. For that
  * backends in all databases have to be considered, so rel = NULL has to be
  * passed in.
  *
@@ -1310,6 +700,10 @@ TransactionIdIsActive(TransactionId xid)
  * The return value is also adjusted with vacuum_defer_cleanup_age, so
  * increasing that setting on the fly is another easy way to make
  * GetOldestXmin() move backwards, with no consequences for data integrity.
+ *
+ *
+ * XXX: We track GlobalXmin in shared memory now. Would it makes sense to
+ * have GetOldestXmin() just return that? At least for the rel == NULL case.
  */
 TransactionId
 GetOldestXmin(Relation rel, int flags)
@@ -1340,7 +734,7 @@ GetOldestXmin(Relation rel, int flags)
 	 * and so protects us against overestimating the result due to future
 	 * additions.
 	 */
-	result = ShmemVariableCache->latestCompletedXid;
+	result = pg_atomic_read_u32(&ShmemVariableCache->latestCompletedXid);
 	Assert(TransactionIdIsNormal(result));
 	TransactionIdAdvance(result);
 
@@ -1383,28 +777,11 @@ GetOldestXmin(Relation rel, int flags)
 	replication_slot_xmin = procArray->replication_slot_xmin;
 	replication_slot_catalog_xmin = procArray->replication_slot_catalog_xmin;
 
-	if (RecoveryInProgress())
-	{
-		/*
-		 * Check to see whether KnownAssignedXids contains an xid value older
-		 * than the main procarray.
-		 */
-		TransactionId kaxmin = KnownAssignedXidsGetOldestXmin();
-
-		LWLockRelease(ProcArrayLock);
+	LWLockRelease(ProcArrayLock);
 
-		if (TransactionIdIsNormal(kaxmin) &&
-			TransactionIdPrecedes(kaxmin, result))
-			result = kaxmin;
-	}
-	else
+	if (!RecoveryInProgress())
 	{
 		/*
-		 * No other information needed, so release the lock immediately.
-		 */
-		LWLockRelease(ProcArrayLock);
-
-		/*
 		 * Compute the cutoff XID by subtracting vacuum_defer_cleanup_age,
 		 * being careful not to generate a "permanent" XID.
 		 *
